#pragma once

#include <QMainWindow>
#include <string>
#include <zmq.hpp>

QT_BEGIN_NAMESPACE
namespace Ui { class MainWindow; }
QT_END_NAMESPACE

class HTTPData {
private:
public:
    size_t index;
    size_t status;
    size_t ttl;
    std::string method;
    std::string url;
    std::string request_headers;
    std::string request_content;
    std::string response_headers;
    std::string response_content;
};

class Worker : public QObject {
    Q_OBJECT
public:
    Worker();
    ~Worker();
public slots:
    void process();
signals:
    void finished();
    void error(QString err);
    void httpMessage(HTTPData);
private:
    // add your variables here
};

class MainWindow : public QMainWindow
{
    Q_OBJECT

private:
    Ui::MainWindow *ui;
    QThread* thread;
public:
    MainWindow(QWidget *parent = nullptr);
    ~MainWindow();
    void httpMessage(HTTPData data);
};
